AllCharNames = {}
country = string.sub(GetCVar("realmList"),1,2)
realm = GetRealmName()

function GetPartyInfo()
	if GetNumRaidMembers() > 0 then
		for i = 1, GetNumRaidMembers() do
			local unitname, unitrealm = UnitName("raid"..i)
				if unitname == nil then break end
				if unitrealm == nil or unitrealm == "" then
					unitrealm = realm
				end
			AllCharNames[unitname.."-"..unitrealm.."-"..country.."\n"] = "";
			--print(unitname.."-"..unitrealm)
		end
	elseif GetNumPartyMembers() > 0 then
		for i = 1, GetNumPartyMembers() do
			local unitname, unitrealm = UnitName("party"..i)
				if unitname == nil then break end
				if unitrealm == nil or unitrealm == "" then
					unitrealm = realm
				end
			AllCharNames[unitname.."-"..unitrealm.."-"..country.."\n"] = "";
			--AllCharNames = AllCharNames..unitname.."-"..unitrealm.."-"..country.."\n"
			--print(unitname.."-"..unitrealm)
		end
	end
end

function GetTargetInfo()
	if UnitIsPlayer("target") then
		local unitname, unitrealm = UnitName("target")
		if unitname == nil then return nil end
		if unitrealm == nil or unitrealm == "" then
			unitrealm = realm
		end
		AllCharNames[unitname.."-"..unitrealm.."-"..country.."\n"] = "";
	end
end

function GetChatInfo(author)
	if author ~= nil and author ~= "" then
		hasRealm = string.find(author, "-")
		if hasRealm == nil then
			author = author.."-"..realm
		end
		author = author.."-"..country.."\n"
		AllCharNames[author] = "";
	end
end

function EventHandler(self, event, ...)
	local arg1, arg2 = ...
	if event == "PLAYER_TARGET_CHANGED" then
		GetTargetInfo()
	elseif event == "PARTY_MEMBERS_CHANGED" then
		GetPartyInfo()
	elseif event == "ADDON_LOADED" and arg1 == "CS490Final" then
		print("Loaded")
		AllCharNames = _G["AllCharNames"]
		if AllCharNames == nil then
			AllCharNames = {}
		end
	elseif event == "PLAYER_LOGOUT" then
		_G["AllCharNames"] = AllCharNames
		print(_G["AllCharNames"])
	elseif arg2 ~= nil then
		GetChatInfo(arg2)
	end
end